<template>
  <ui-button
    class="ui-navbar-toggle-button !border-none !bg-transparent !p-1 !text-lg !text-gray-700 !shadow-none !ring-opacity-100 hover:!text-violet-700 focus:!text-violet-700 focus:!ring-violet-700"
    :aria-expanded="open ? 'true' : 'false'"
    v-bind="$attrs"
  >
    <template v-if="iconSlot" #[iconSlot]>
      <bars-3-icon v-if="!open" class="stroke-2" />
      <x-mark-icon v-else class="stroke-2" />
    </template>
    <slot>Menu</slot>
  </ui-button>
</template>

<script lang="ts" setup>
import { computed } from 'vue'
import { Bars3Icon, XMarkIcon } from '@heroicons/vue/24/outline'

import UiButton from './Button.vue'

defineOptions({
  name: 'UiNavbarToggleButton',
})

const props = defineProps({
  open: {
    type: Boolean,
    default: false,
  },
  iconLeft: {
    type: Boolean,
    default: false,
  },
  iconRight: {
    type: Boolean,
    default: true,
  },
})

const iconSlot = computed(() => {
  // since iconRight is the default slot, iconLeft overrides it
  if (props.iconLeft) {
    return 'iconLeft'
  }
  if (props.iconRight) {
    return 'iconRight'
  }

  return ''
})
</script>
